precision highp float;
uniform sampler2D inputTexture;
varying vec2 textureCoordinate;

uniform float u_diff;
uniform float u_invert;
uniform float u_rotate;
uniform vec2 u_center;
uniform vec2 u_size;

void main() {
    vec2 coord = (textureCoordinate - u_center) * u_size;
    float value = dot(coord, vec2(sin(u_rotate), -cos(u_rotate)));
    float diff = max(u_diff, 1e-5);
    float fade = value >= 0.0 ? smoothstep(0.0, 1.0, clamp(value, 0.0, diff) / diff) : 0.0;
    gl_FragColor = vec4(vec3(1.0, 1.0, 1.0), u_invert > 0.0 ? fade : 1.0 - fade) * texture2D(inputTexture, textureCoordinate);
}
